angular.module('NHTMRIApp', ['ionic','ngCordova','ionic.service.core','NHTMRIApp.controllers','NHTMRIApp.services','ionic-zoom-view','ion-gallery'])

.run(function($ionicPlatform, ProgramService, SiteService, AbstractsService ,$rootScope, $cordovaSplashscreen, $ionicPopup, $ionicLoading) {
  $ionicPlatform.ready(function() {
    
    //We will hide it for a while
    /*$ionicLoading.show({
      templateUrl: 'templates/loading.html'
    });*/
    
    /*
    var programFile = 'http://nhtmri.net/public/dataobject.js';
    var rawFile = new XMLHttpRequest();
    var programDataObject = null;
    rawFile.open("GET", programFile, false);
    rawFile.onreadystatechange = function () {
      if(rawFile.readyState === 4) {
        if(rawFile.status === 200 || rawFile.status == 0) {
          data = rawFile.responseText;
          programDataObject = JSON.parse(data);
        }
      }
    }
    rawFile.send(null);
    */

    // Get ALL Data Object !
    $rootScope.getProgramStatic = function(data) {
      // First : Get Data
      $rootScope.programDetails = data.data;
      ProgramService.setProgram(data);
      $rootScope.speakers = ProgramService.getSpeakers('Speaker','Participant');
      $rootScope.sessions = ProgramService.getSessions($rootScope.programDetails);
      $rootScope.topics = ProgramService.getTopics($rootScope.sessions);
      $rootScope.halls = ProgramService.getHalls($rootScope.sessions);
      $rootScope.days = ProgramService.getDays($rootScope.programDetails);
      $rootScope.topicsPerDay = ProgramService.getTopicsPerDay();

      // Second : Inject Data
      SessionCtrl = angular.element($('[ng-app=NHTMRIApp]')).scope();
      SessionCtrl.program = $rootScope.programDetails;
      SessionCtrl.sessions = $rootScope.sessions;
      SessionCtrl.topics = $rootScope.topics;
      SessionCtrl.speakers = $rootScope.speakers;
      SessionCtrl.halls = $rootScope.halls;
      SessionCtrl.days = $rootScope.days;
    };
    //$rootScope.getProgramStatic(programDataObject);

    // Get ALL Data Object !
    $rootScope.getProgram = function() {
      ProgramService.getProgram().then(function(data){
        // First : Hide Loading
        $ionicLoading.hide();
        if(!data){ // Loading Faild Case
          // Error Global Var
          $rootScope.errorLoading = true;
          // Check If LoacalStorage Have Version
          if(localStorage.allData){
            // Stringify Object
            $rootScope.allData = JSON.parse(localStorage.allData);
            // First : Get Data
            $rootScope.programDetails = $rootScope.allData.data;
            ProgramService.setProgram($rootScope.allData);
            $rootScope.speakers = ProgramService.getSpeakers('Speaker','Participant');
            $rootScope.sessions = ProgramService.getSessions($rootScope.programDetails);
            $rootScope.topics = ProgramService.getTopics($rootScope.sessions);
            $rootScope.halls = ProgramService.getHalls($rootScope.sessions);
            $rootScope.days = ProgramService.getDays($rootScope.programDetails);
            $rootScope.topicsPerDay = ProgramService.getTopicsPerDay();
            // Second : Get All Scopes
            SessionCtrl = angular.element($('[ng-app=NHTMRIApp]')).scope();
            // Cancel Error Screen
            $rootScope.errorLoading = false;
            // Inject Data
            SessionCtrl.program = $rootScope.programDetails;
            SessionCtrl.sessions = $rootScope.sessions;
            SessionCtrl.topics = $rootScope.topics;
            SessionCtrl.speakers = $rootScope.speakers;
            SessionCtrl.halls = $rootScope.halls;
            SessionCtrl.days = $rootScope.days;
          }else{
            // If No Data Saved In LocalStorage
            console.log('Error Loading Local Storage');
            // Set Error
            $rootScope.errorLoading = true;
          }
          // Second : Show Popup
           var myPopup = $ionicPopup.show({
             template: 'The program section may not be available',
             title: '<h3>No Internet Access</h3>',
             subTitle: '<h5>Please Check Your Internet Connection</h5>',
             buttons: [{text: '<b>Continue Using The App</b>',type: 'button-positive'}]
           });
        } else{ //Internet Connection Found 
          // Loading Success
          $rootScope.errorLoading = false; // Cancel Error State
          // Set Backup At LocalStorage
          localStorage.setItem('allData', JSON.stringify(data));

          // First : Get Data
          $rootScope.programDetails = data.data;
          $rootScope.speakers = ProgramService.getSpeakers('Speaker','Participant');
          $rootScope.sessions = ProgramService.getSessions($rootScope.programDetails);
          $rootScope.topics = ProgramService.getTopics($rootScope.sessions);
          $rootScope.halls = ProgramService.getHalls($rootScope.sessions);
          $rootScope.days = ProgramService.getDays($rootScope.programDetails);
          $rootScope.topicsPerDay = ProgramService.getTopicsPerDay();

          // Second : Inject Data
          SessionCtrl = angular.element($('[ng-app=NHTMRIApp]')).scope();
          SessionCtrl.program = $rootScope.programDetails;
          SessionCtrl.sessions = $rootScope.sessions;
          SessionCtrl.topics = $rootScope.topics;
          SessionCtrl.speakers = $rootScope.speakers;
          SessionCtrl.halls = $rootScope.halls;
          SessionCtrl.days = $rootScope.days;
        }
      });
    };
    $rootScope.getProgram();

    //Get Abstracts
    $rootScope.loadAbstracts = function() {
      AbstractsService.getAbstracts().then(function(response){
        AbstractsCtrl = angular.element($('[ng-app=NHTMRIApp]')).scope();
        if(response) {
          localStorage.setItem('abstractsData', JSON.stringify(response.data)); // Set Backup At LocalStorage
          AbstractsCtrl.abstracts = response.data;
        } else {
          if(localStorage.abstractsData) {
            AbstractsCtrl.abstracts = localStorage.abstractsData;
          }
          console.log('abstracts not loaded')
        }
      });
    };
    $rootScope.loadAbstracts();

    // Get ALL Data Object !
    $rootScope.getSiteSections = function($section) {
      SiteService.getSectionList($section).then(function(data){

        if(!data)
        {

        } else {
          $rootScope.response = data.data;
          DepartmentsCtrl = angular.element($('[ng-app=NHTMRIApp]')).scope();
          if($section=='departments') {
            DepartmentsCtrl.departments = $rootScope.response;
          } else if($section=='units') {
            DepartmentsCtrl.units = $rootScope.response;
          } else if($section=='services') {
            DepartmentsCtrl.services = $rootScope.response;
          } else if($section=='pages') {
            DepartmentsCtrl.pages = $rootScope.response;
          } else if($section=='citizens') {
            DepartmentsCtrl.citizens = $rootScope.response;
          }
        }
        console.log('Section:'+$section+' received');
      });
    };
    /*
    $rootScope.getSiteSections('departments');
    $rootScope.getSiteSections('units');
    $rootScope.getSiteSections('services');
    */

    $rootScope.getAllSections = function() {
      SiteService.getAllMainSections().then(function(data){

        DepartmentsCtrl = angular.element($('[ng-app=NHTMRIApp]')).scope();
        DepartmentsCtrl.noDataLoaded = false;

        if(!data)
        {
          if(localStorage.allSectionsStorage){
            $rootScope.StorageData = JSON.parse(localStorage.allSectionsStorage);
            $rootScope.allSections = $rootScope.StorageData.data;
            DepartmentsCtrl.departments = $rootScope.allSections.department;
            DepartmentsCtrl.units = $rootScope.allSections.unit;
            DepartmentsCtrl.services = $rootScope.allSections.service;
          } else {
            DepartmentsCtrl.noDataLoaded = true;
          }
        } else {
          localStorage.setItem('allSectionsStorage', JSON.stringify(data));
          $rootScope.allSections = data.data;
          DepartmentsCtrl.departments = $rootScope.allSections.department;
          DepartmentsCtrl.units = $rootScope.allSections.unit;
          DepartmentsCtrl.services = $rootScope.allSections.service;
        }
      });
    };
    $rootScope.getAllSections();

    // Reload App Func
    $rootScope.reloadApp = function(){
      $ionicLoading.show({
        templateUrl: 'templates/loading.html'
      });
      ProgramService.getProgram().then(function(data){
        // First : Hide Loading
        $ionicLoading.hide();
        if(!data){
          // Loading Faild Case

          // Error Global Var
          $rootScope.errorLoading = true;
          // Second : Show Popup
           var myPopup = $ionicPopup.show({
             template: 'You Still Can Use The App But Some Sections Will Be Unavailable Until Recovering Internet Connection',
             title: '<h3>No Internet Access</h3>',
             subTitle: '<h5>Please Check Your Internet Connection</h5>',
             buttons: [{text: '<b>Continue Using The App</b>',type: 'button-positive'}]
           });
        }else{
          // Loading Success
          $rootScope.errorLoading = false; // Cancel Error State
          // Set Backup At LocalStorage
          localStorage.setItem('allData', JSON.stringify(data));
          // Finally Reload
          location.reload(true);
        }
      });
    }

    $rootScope.getWhatsNow = function() {
      ProgramService.getNowTopics().then(function(data){
        if(data) {
          $rootScope.whatsNow = data.data;
          $rootScope.whatsNowCount = Object.keys(data.data).length;

          MenuCtrl = angular.element($('[ng-controller=MenuCtrl]')).scope();
          MenuCtrl.countNowTopics = $rootScope.whatsNowCount;
        }
      });
    };
    $rootScope.getWhatsNow();

    //Program Settings
    $rootScope.program_settings = {
      'view_specialty':false,
      'view_country':false
    };

    $rootScope.format_date = function(value) {
      return new Date(value);
    };

    $rootScope.alert = function(title,text, buttonType) {
      if(buttonType == null) {
        buttonType = 'button-positive';
      }
       var alertPopup = $ionicPopup.alert({title: title, template: text, buttons:[{text:'OK', type: buttonType}] });
    };

    /* Show / Hide Tabs */
    $rootScope.hide = function(elements) {
      elements = elements.length ? elements : [elements];
      for (var index = 0; index < elements.length; index++) {
        elements[index].style.display = 'none';
      }
    };

    $rootScope.showTab = function(itemID, tabContainer, tabItem) {
        if(!tabContainer) {
          tabContainer = 'tabContent';
        }
        if(!tabItem) {
          tabItem = 'tab-item';
        }
        var tabs = document.getElementsByClassName(tabContainer);
        $rootScope.hide(tabs);
        document.getElementById(itemID).style.display = 'block';
        var allTabs = document.getElementsByClassName(tabItem);
        for (var i = 0; i <= allTabs.length-1; i++) {
          document.getElementsByClassName(tabItem)[i].classList.remove('active');
        };
        document.getElementById(tabItem+'_'+itemID).className = 'tab-item '+tabItem+' active';
    };

    $rootScope.sortByKey = function(array, key) {
        return array.sort(function(a, b) {
            var x = a[key]; var y = b[key];
            return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        });
    };

    //Handle Cordova InAppBrowser for External Links
    $rootScope.goTo = function($url) {
      var ref = cordova.InAppBrowser.open($url, '_blank', 'location=yes');
      ref.addEventListener('loadstart', function(event) { 
          $(".bsmb").val('loading...');
      });
    };
    //Ionic Analytics
    //$ionicAnalytics.register();

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.constant('ApiEndpoint', {
  url: 'http://nhtmri.net/public/api'
})

.filter('unsafe', function($sce) { return $sce.trustAsHtml; })

.filter('cut', function () {
    return function (value, wordwise, max, tail) {
        if (!value) return '';

        max = parseInt(max, 10);
        if (!max) return value;
        if (value.length <= max) return value;

        value = value.substr(0, max);
        if (wordwise) {
            var lastspace = value.lastIndexOf(' ');
            if (lastspace != -1) {
                value = value.substr(0, lastspace);
            }
        }
        return value + (tail || ' …');
    };
})

.directive('browseTo', function ($ionicGesture) {
 return {
  restrict: 'A',
  link: function ($scope, $element, $attrs) {
   var handleTap = function (e) {
    // todo: capture Google Analytics here
    var inAppBrowser = window.open(encodeURI($attrs.browseTo), '_system');
   };
   var tapGesture = $ionicGesture.on('tap', handleTap, $element);
   $scope.$on('$destroy', function () {
    // Clean up - unbind drag gesture handler
    $ionicGesture.off(tapGesture, 'tap', handleTap);
   });
  }
 }
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

  .state('app.home', {url: '/home', views: { 'menuContent': { templateUrl: 'templates/home.html' }}})
  .state('app.welcome', { url: '/welcome', views: { 'menuContent': { templateUrl: 'templates/welcome.html' }}})
  .state('app.board', { url: '/board', views: { 'menuContent': { templateUrl: 'templates/board.html' }}})

  .state('app.highlights', { url: '/program/highlights', views: { 'menuContent': { templateUrl: 'templates/program/highlights.html' }}})
  .state('app.program', { url: '/program/program', views: { 'menuContent': { templateUrl: 'templates/program/program.html' }}})
  .state('app.programhalls', { url: '/program/programhalls', views: { 'menuContent': { templateUrl: 'templates/program/programhalls.html' }}})
  .state('app.speakers', { url: '/program/speakers', views: { 'menuContent': { templateUrl: 'templates/program/speakers.html' }}})
  .state('app.committee', { url: '/committee', views: { 'menuContent': { templateUrl: 'templates/committee.html' }}})
  .state('app.participants', { url: '/participants', views: { 'menuContent': { templateUrl: 'templates/participants.html' }}})
  .state('app.collaborators', { url: '/collaborators', views: { 'menuContent': { templateUrl: 'templates/collaborators.html' }}})
  .state('app.ginfo', { url: '/general_info', views: { 'menuContent': { templateUrl: 'templates/general_information.html' }}})

  .state('app.session', { url: '/program/session/:sessionId', views: { 'menuContent': { templateUrl: 'templates/program/session.html' }}})
  .state('app.sessions', { url: '/program/sessions', views: { 'menuContent': { templateUrl: 'templates/program/sessions.html' }}})
  .state('app.topics', { url: '/program/topics', views: { 'menuContent': { templateUrl: 'templates/program/topics.html' }}})
  .state('app.speaker', { url: '/program/speaker/:name', views: { 'menuContent': { templateUrl: 'templates/program/speaker.html' }}})
  .state('app.whatsnow', { url: '/program/whats_now', views: { 'menuContent': { templateUrl: 'templates/program/whats_now.html' }}})
  .state('app.myquestions', { url: '/program/myquestions', views: { 'menuContent': { templateUrl: 'templates/program/myquestions.html' }}})
  .state('app.question', { url: '/program/question/:subject', views: { 'menuContent': { templateUrl: 'templates/program/myquestion_details.html' }}})
  .state('app.abstracts', { url: '/program/abstracts', views: { 'menuContent': { templateUrl: 'templates/abstracts/abstracts.html' }}})
  .state('app.abstractdetails', {url:'/program/abstract_details/:abstract_id', views: { 'menuContent': {templateUrl:'templates/abstracts/abstract_details.html'}}})
  .state('app.t_rating', {url:'/rating/:topic_id', views: {'menuContent':{templateUrl: 'templates/rating/topic.html'}}})

  .state('app.guests', { url: '/program/guests', views: { 'menuContent': { templateUrl: 'templates/sp_international.html' }}})
  .state('app.main-topics', { url: '/program/main-topics', views: { 'menuContent': { templateUrl: 'templates/main-topics.html' }}})
  .state('app.workshop', { url: '/program/workshop', views: { 'menuContent': { templateUrl: 'templates/workshop.html' }}})
  //.state('app.accreditation', { url: '/program/accreditation', views: { 'menuContent': { templateUrl: 'templates/accreditation.html' }}})
  
  .state('app.inter', { url: '/speakers/inter', views: { 'menuContent': { templateUrl: 'templates/sp_international.html' }}})
  .state('app.reg', { url: '/speakers/reg', views: { 'menuContent': { templateUrl: 'templates/sp_regional.html' }}})

  .state('app.register', {url: '/register',views: { 'menuContent': { templateUrl: 'templates/register.html' }}})
  .state('app.accommodation', {url: '/accommodation',views: { 'menuContent': { templateUrl: 'templates/accommodation.html' }}})
  .state('app.sponsors', {url: '/sponsors',views: { 'menuContent': { templateUrl: 'templates/sponsors.html' }}})

  .state('app.past', { url: '/past', views: { 'menuContent': { templateUrl: 'templates/past.html' }}})
  .state('app.gallery', { url: '/gallery', views: { 'menuContent': { templateUrl: 'templates/gallery.html' }}})

  .state('app.nabout',{url:'/nhtmri/about', views:{ 'menuContent': { templateUrl: 'templates/nhtmri/about.html' }}})
  .state('app.nmission',{url:'/nhtmri/mission', views:{ 'menuContent': { templateUrl: 'templates/nhtmri/mission.html' }}})
  .state('app.nboard',{url:'/nhtmri/board', views:{ 'menuContent': { templateUrl: 'templates/nhtmri/board.html' }}})
  .state('app.ndepts',{url:'/nhtmri/departments',views:{'menuContent':{templateUrl:'templates/nhtmri/departments.html'}}})
  .state('app.nunits',{url:'/nhtmri/units',views:{'menuContent':{templateUrl:'templates/nhtmri/units.html'}}})
  .state('app.nservices',{url:'/nhtmri/services',views:{'menuContent':{templateUrl:'templates/nhtmri/services.html'}}})
  .state('app.dept_show', { url: '/nhtmri/show/:sectionType/:sectionId', views: { 'menuContent': { templateUrl: 'templates/nhtmri/show.html' }}})

  .state('app.connect', { url: '/connect', views: { 'menuContent': { templateUrl: 'templates/connect.html' }}})
  .state('app.contact', { url: '/contact', views: { 'menuContent': { templateUrl: 'templates/contact.html' }}})
  .state('app.egypt', { url: '/egypt', views: { 'menuContent': { templateUrl: 'templates/egypt.html' }}})
  .state('app.about', { url: '/about', views: { 'menuContent': { templateUrl: 'templates/about.html' }}})
  .state('app.venue', { url: '/venue', views: { 'menuContent': { templateUrl: 'templates/venue.html' }}})
  .state('app.location', { url: '/location', views: { 'menuContent': { templateUrl: 'templates/location.html' }}})
  .state('app.departments', { url: '/departments', views: { 'menuContent': { templateUrl: 'templates/under-construction.html' }}})
  .state('app.units', { url: '/units', views: { 'menuContent': { templateUrl: 'templates/under-construction.html' }}})
  .state('app.services', { url: '/services', views: { 'menuContent': { templateUrl: 'templates/under-construction.html' }}})
  .state('app.structure', { url: '/structure', views: { 'menuContent': { templateUrl: 'templates/under-construction.html' }}})
  .state('app.exhibition', { url: '/exhibition', views: { 'menuContent': { templateUrl: 'templates/exhibition.html' }}})
  .state('app.regform', { url: '/registerform', views: { 'menuContent': { templateUrl: 'templates/register/form.html' }}})

  .state('app.confMaterials', { url: '/conf_materials', views: { 'menuContent': { templateUrl: 'templates/materials/index.html' }}})
  

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
});
