angular.module('NHTMRIApp.controllers')

.controller('EgyptCtrl', function($scope, $ionicModal,$location,$ionicScrollDelegate){
  // About Egypt Slider
  $scope.sliderItems = [
    'img/egypt/1.jpg',
    'img/egypt/2.jpg',
    'img/egypt/3.jpg',
    'img/egypt/4.jpg',
    'img/egypt/5.jpg',
    'img/egypt/6.jpg',
    'img/egypt/7.jpg',
    'img/egypt/8.jpg'
  ];
  // Places Modals
  // First Places Array Object
  $scope.places = [{
    name: 'Khan El-Khalili',
    image: 'img/egypt/9.jpg',
    desc: "No visit to Cairo is Complete without a stop at the Khan El-Khalili bazaar, where you will be transported back in time to an old Arab souk. Shop owners calling you to their stalls, the scent of spices, the hustle and bustle of trade, and the many beautiful objects that can purchased will have you lost among alleys for hours. Put your haggling skills to the test when buying statuettes, spices, souvenirs, silver jewellery, t-shirts, galabiyyas, belly dancing costumes, or anything for that matter. When your shopping's done, dont miss out on a traditional cup of tea at the famous Fishawi's cafe."
  }, {
    name: 'Beyt El-Suhaimi',
    image: 'img/egypt/10.jpg',
    desc: "Gazing at the typically plain and maybe – to some – even dull façade of Beyt el-Suhaimi, you cannot imagine the architectural treasures you will witness inside. This mansion is Islamic Cairo's finest example of the traditional family residences built throughout the city from Mamluk times to the 19th century. Once you enter the house, you will emerge into a beautiful inner courtyard transporting you to the days where guests were received in the adjacent impressive reception room, the 'qa'a.' Set around a magnificent marble fountain inset in the floor, the room has also a high painted wooden ceiling you’ll discover after following the most delicate green and blue patterned enamel tiles on the walls. Going upstairs, you will discover the family apartments and the wooden lattice windows, known as “mashrabiya”, allowing women of the house to observe the street life below without being seen. And again, have a look at the very high ceilings which allowed the warmer air to rise and then to be swept away by the north facing maqad (wind scoops) in the upper walls which caught the breeze. A precursor of today's air-conditioning systems, you might think. And so it was; this architectural feature really helped in making life easier in Cairo's dry and hot weather. Ticket Price(s): Regular: 30 EGP Student: 15 EGP"
  }, {
    name: 'Cairo Opera House',
    image: 'img/egypt/11.jpg',
    desc: "You would never guess from its non-stop schedule of activities that the Cairo Opera house burned to the ground in 1971. From Verdi’s “Aida” to medleys on Um Kulthoum’s music to Orff’s “Carmina Burana” to pop concerts by local bands, the Cairo Opera has risen like a true phoenix from the ashes. Located on the upscale island of Zamalek, the Opera House is a gem of postmodern architecture. Originally designed in 1869 during the Khedive Ismail's reign by Italian architects Avoscani and Rossi to celebrate the opening of the Suez Canal, its redesign by a Japenese architect was unveiled in 1988. The Opera House is home to two main concert halls and an open air theatre, as well as a museum dedicated to sharing its history. Visitors to the museum can see such attractions as costumes given to the New Cairo Opera House by the Vienna State Opera, and a model of the New Opera House buildings and photos while it was under construction, as well as a 2 metres long Arab flute, the Nay. Visit the Cairo Opera House website for an updated calendar of events, or call the following numbers: - Information: +20 2 2739 8144, +20 2 2739 0144 - Ticketing Office: +20 2 2739 0114, + 20 2 2739 8114"
  }, {
    name: 'Al-Ghouri Complex ',
    image: 'img/egypt/12.jpg',
    desc: "Sultan Qansuh Al-Ghouri was a Mamluk sultan, who had reigned from 1501 to 1516, before dying in a battle against the Ottomans in Aleppo, which resulted in a complete defeat for the Mamluks, due to which they lost their prominence in Egypt. Al-Ghouri spent a fortune on building his complex in Cairo which dates back to 1503. Although he was renowned for his cruelty and despotism, he was also known for his love of flowers, music, poetry and architecture. His cultural refinement emanates from the different features of the complex. The construction stands on both sides of Al-Mo'ez Street; the mosque and madrasa stand on the western side, whereas you will find the khanqah, mausoleum and Sabil-Kuttab on the eastern side of the famous street. The mausoleum is however not the final resting place of the Sultan, whose body was never recovered after the Aleppo battle. The two parts of the complex aren’t adjusted to the street alignment, thus creating a free shaped courtyard in between the two buildings. The mosque’s minaret has four stories, just like the original minaret of the Aqsunqur mosque (the Blue Mosque). These are the only two minarets in Cairo known to have four stories, instead of the usual three. Since 1995, the complex hosts various cultural events in the Khanqah hall, mostly Nubian music concerts, Tannoura dance performances, and religious recitals. Ticket Price(s): Regular: 25 EGP Student: 15 EGP"
  }];
  // Modal Object
  $scope.modalPlace = {
    name: '',image: '',desc:''
  };
  $ionicModal.fromTemplateUrl('templates/place-item.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openPlaceModal = function(placeID) {
    $scope.modalPlace.name = $scope.places[placeID]['name'];
    $scope.modalPlace.image = $scope.places[placeID]['image'];
    $scope.modalPlace.desc = $scope.places[placeID]['desc'];
    $scope.modal.show();
  };
  $scope.closePlaceModal = function() {
    $scope.modal.hide();
  };

  $scope.scrollTo = function (id) {
     $location.hash(id);
     var delegateHandle = $ionicScrollDelegate.$getByHandle('myContent');
     delegateHandle.anchorScroll(id);
  };
})