angular.module('NHTMRIApp.services', ['ionic.service.core','ionic.service.analytics'])

.factory('ProgramService', ['$http', function($http){
	var speakers = [];
	var program = [];
	var programHalls = [];
	var sessions = [];
	var topics = [];
	var topicsPerDay = [];
	var nowTopics = [];
	var halls = [];
	var days = [];
	var $api_path = 'http://think-ds.com/projects/eventprogram/public/api/';

	return {
		setProgram: function(programObject) {
			program = programObject;
		},

		getProgram: function() {
			return $http.get($api_path+'programbyday?event_id=21').then(function(response){
				program = response;
				return program;
			}, function(error){
				return false;
			})
		},

		getProgramByHall: function() {
			return $http.get($api_path+'programbyhall?event_id=21').then(function(response){
				console.log('program By Halls API loaded');
				programHalls = response;
				return programHalls;
			});
		},

		getSessions: function(programObj) {
			var sessionsList = [];
			if(programObj.length==0) {
				programObj = program;
			}
			if(programObj.length>0) {
				for(i=0;i<programObj.length;i++)
				{
					var sessionsInside = programObj[i].sessions;
					for (j=0; j<sessionsInside.length;j++)
					{
						sessionsList.push(sessionsInside[j]);
					}
			    }
			} else {
				return $http.get($api_path+'session-topics?event_id=21').then(function(response){
					console.log('session_topics API loaded');
					sessionsList = response;
				}, function(error){
					sessionsList = 0;
				});
			}
			sessions = sessionsList;
			return sessionsList;
		},

		getHalls: function(sessionsObj) {
			var lookup = {};
			var items = sessionsObj;
			var hallsList = [];

			for (var item, i = 0; item = items[i++];) {
			  var hall_no = item.hall_no;
			  if (!(hall_no in lookup)) {
			    lookup[hall_no] = 1;
			    hallsList.push(hall_no);
			  }
			}
			hallsList.sort();
		    halls = hallsList;
		    return halls;
		},

		getTopics: function(sessions_list) {
			var topicsList = [];
			var topicsByDay = [];

			if(program.length!=0)
			{
				var programObj = program.data;
				for(i=0;i<programObj.length;i++)
				{
					var topicsDaily = [];
					var sessionsObj = programObj[i].sessions;
			      	for (j=0; j<sessionsObj.length;j++)
			      	{
			      		var topicsObj = sessionsObj[j].topics;
			      		var jsObj = [];
			      		for (k=0; k<topicsObj.length;k++)
			      		{
				    		topicsList.push(topicsObj[k]);
				    		topicsDaily.push(topicsObj[k]);
				    	}
				    }
				    var objToTopicsPerDay = {day: programObj[i], topics: topicsDaily};
				    topicsByDay.push(objToTopicsPerDay);
			    }
			}
			topics = topicsList;
			topicsPerDay = topicsByDay;
			return topicsList;
		},

		getTopicsPerDay: function() {
			return topicsPerDay;
		},

		getSpeakers: function(personType,orType) {
			if(personType==null) {
				personType='Speaker';
			}
			if(orType==null) {
				orType='Speaker';
			}
			var speakerList = [];
			if(program)
			{
				var programObj = program.data;
				for(i=0;i<programObj.length;i++)
				{
					var sessionsObj = programObj[i].sessions;
			      	for (j=0; j<sessionsObj.length;j++)
			      	{
			      		var topicsObj = sessionsObj[j].topics;
			      		for (k=0; k<topicsObj.length;k++)
			      		{
				    		if(topicsObj[k].type==personType || topicsObj[k].type==orType) {
				    			var personObj = {name: topicsObj[k].person, country: topicsObj[k].country};
				    			speakerList.push(personObj);
				    		}
				    	}
				    }
			    }
			} else {
				return $http.get($api_path+'speakers?event_id=21').then(function(response){
					console.log('speakers API loaded');
					speakerList = response;
				});
			}
			return speakerList;
		},

		getSpeaker: function(name) {
			var speakerTopics = [];
			var sessions_list = sessions;
		    for(i=0;i<sessions_list.length;i++){
		    	var topics = sessions_list[i].topics;
		      	for (j=0; j<topics.length;j++) {
			    	if(topics[j].person.trim()==name.trim()) {
			    		topics[j]['date'] = sessions_list[i].day.date;
			    		speakerTopics.push(topics[j]);
			    	}
			    }
		    }
			return speakerTopics;
		},

		getTopic: function(topic_id) {
			var topic = [];
	      	for (j=0; j<topics.length;j++) {
		    	if(topics[j].id==topic_id) {
		    		topic = topics[j];
		    		break;
		    	}
		    }
			return topic;
		},

		getSessionMembers: function(personType, SessionDetails, orPersonType) {
			if(personType==null) {
				personType='Speaker';
			}
			var personsList = [];
			
      		var topicsObj = SessionDetails.topics;
      		for (k=0; k<topicsObj.length;k++)
      		{
	    		if((topicsObj[k].type.toLowerCase() == personType.toLowerCase())) {
	    			personsList.push(topicsObj[k]);
	    		}

	    		if(orPersonType!=null && (topicsObj[k].type.toLowerCase() == orPersonType.toLowerCase())) {
	    			personsList.push(topicsObj[k]);
	    		}
	    	}
			return personsList;
		},

		getNowTopics: function() {
			return $http.get($api_path+'now?event_id=21').then(function(response){
				console.log('NOW topics API loaded');
				return response;
			});
		},

		getNowTopicsQuick: function() {
			return $http.get($api_path+'now?event_id=21').then(function(response){
				console.log('NOW topics API loaded');
				return response;
			});
		},

		getDays: function(programObj) {
			var lookup = {};
			var items = programObj;
			var daysList = [];

			for (var item, i = 0; item = items[i++];) {
			  var day_no = item.date;
			  if (!(day_no in lookup)) {
			    lookup[day_no] = 1;
			    daysList.push(item);
			  }
			}
		    days = daysList;
		    return days;
		},
	}
}])

.factory('QuestionService', ['$http', function($http){
	var $api_path = 'http://think-ds.com/projects/eventprogram/public/api/';
	return {
		submitQuestion: function(data) {
			return $http.post($api_path+'question', data).then(function(response) {
				console.log(response);
				return response;
			});
		},
	}
}])

.factory('AbstractsService', ['$http', function($http){
	var $abstracts = [];
	return {
		getAbstracts: function() {
			return $http.get('http://think-ds.com/projects/eventprogram/public/api/abstracts?event_id=21').then(function(response) {
				abstracts = response.data;
				return response;
			});
		},
		getAbstract: function(abstract_id) {
			var abstract = [];
	      	for (j=0; j<abstracts.length;j++) {
		    	if(abstracts[j].id==abstract_id) {
		    		abstract = abstracts[j];
		    		break;
		    	}
		    }
			return abstract;
		}
	}
}])

.factory('ReviewsService', ['$http', function($http) {
	return {
		submitReview: function(data) {
			return $http.post('http://think-ds.com/projects/eventprogram/public/api/submit-review', data).then(function(response) {
				console.log(response);
				return response;
			});
		},
		getTopic: function(topic_id) {
			return $http.get('http://think-ds.com/projects/eventprogram/public/api/topic/'+topic_id).then(function(response) {
				return response;
			});
		},
	}
}])

.factory('SiteService', ['$http', function($http){
	var section = [];
	var $api_path = 'http://nhtmri.net/public/api/';
	var allSections = [];

	return {
		getAllMainSections: function() {
			return $http.get($api_path+'site-sections/allsections').then(function(response){
				allSections = response;
				return allSections;
			}, function(error){
				return false;
			})
		},

		getSingleSection: function(dataObject, $section) {
			console.log(dataObject.$section);
		},

		getSectionList: function() {
			return $http.get($api_path+'site-sections').then(function(response){
				section = response;
				return section;
			}, function(error){
				return false;
			})
		},

		getSection: function(dataObject,type, id) {
			var data = null;
			var response = null;

			if(type=='department') { data = dataObject.department; }
			else if(type=='unit') { data = dataObject.unit; }
			else if(type=='service') { data = dataObject.service; }
			else {}

			for($i=0;$i<data.length;$i++)
			{
				if(data[$i].id == id) {
					response.push(data[$i]);
				}
			}
			return response;
		},
	}
}])